Index: lemon/elevator.h
===================================================================
--- lemon/elevator.h	(revision 581)
+++ lemon/elevator.h	(revision 519)
@@ -47,8 +47,8 @@
   ///\sa LinkedElevator
   ///
-  ///\param GR Type of the underlying graph.
-  ///\param Item Type of the items the data is assigned to (\c GR::Node,
-  ///\c GR::Arc or \c GR::Edge).
-  template<class GR, class Item>
+  ///\param Graph Type of the underlying graph.
+  ///\param Item Type of the items the data is assigned to (Graph::Node,
+  ///Graph::Arc, Graph::Edge).
+  template<class Graph, class Item>
   class Elevator
   {
@@ -61,8 +61,8 @@
 
     typedef Item *Vit;
-    typedef typename ItemSetTraits<GR,Item>::template Map<Vit>::Type VitMap;
-    typedef typename ItemSetTraits<GR,Item>::template Map<int>::Type IntMap;
-
-    const GR &_g;
+    typedef typename ItemSetTraits<Graph,Item>::template Map<Vit>::Type VitMap;
+    typedef typename ItemSetTraits<Graph,Item>::template Map<int>::Type IntMap;
+
+    const Graph &_g;
     int _max_level;
     int _item_num;
@@ -77,5 +77,5 @@
     void copy(Item i, Vit p)
     {
-      _where[*p=i] = p;
+      _where.set(*p=i,p);
     }
     void copy(Vit s, Vit p)
@@ -85,5 +85,5 @@
           Item i=*s;
           *p=i;
-          _where[i] = p;
+          _where.set(i,p);
         }
     }
@@ -92,6 +92,6 @@
       Item ti=*i;
       Vit ct = _where[ti];
-      _where[ti] = _where[*i=*j];
-      _where[*j] = ct;
+      _where.set(ti,_where[*i=*j]);
+      _where.set(*j,ct);
       *j=ti;
     }
@@ -106,5 +106,5 @@
     ///\param max_level The maximum allowed level.
     ///Set the range of the possible labels to <tt>[0..max_level]</tt>.
-    Elevator(const GR &graph,int max_level) :
+    Elevator(const Graph &graph,int max_level) :
       _g(graph),
       _max_level(max_level),
@@ -123,7 +123,7 @@
     ///Set the range of the possible labels to <tt>[0..max_level]</tt>,
     ///where \c max_level is equal to the number of labeled items in the graph.
-    Elevator(const GR &graph) :
+    Elevator(const Graph &graph) :
       _g(graph),
-      _max_level(countItems<GR, Item>(graph)),
+      _max_level(countItems<Graph, Item>(graph)),
       _item_num(_max_level),
       _where(graph),
@@ -227,5 +227,5 @@
     {
       Item it = *_last_active[_highest_active];
-      ++_level[it];
+      _level.set(it,_level[it]+1);
       swap(_last_active[_highest_active]--,_last_active[_highest_active+1]);
       --_first[++_highest_active];
@@ -250,5 +250,5 @@
         }
       copy(li,_first[new_level]);
-      _level[li] = new_level;
+      _level.set(li,new_level);
       _highest_active=new_level;
     }
@@ -270,5 +270,5 @@
       copy(li,_first[_max_level]);
       --_last_active[_max_level];
-      _level[li] = _max_level;
+      _level.set(li,_max_level);
 
       while(_highest_active>=0 &&
@@ -300,5 +300,5 @@
     {
       Item it =*_last_active[level];
-      ++_level[it];
+      _level.set(it,_level[it]+1);
       swap(_last_active[level]--, --_first[level+1]);
       if (level+1>_highest_active) ++_highest_active;
@@ -320,5 +320,5 @@
         }
       copy(ai,_first[new_level]);
-      _level[ai] = new_level;
+      _level.set(ai,new_level);
       if (new_level>_highest_active) _highest_active=new_level;
     }
@@ -340,5 +340,5 @@
       copy(ai,_first[_max_level]);
       --_last_active[_max_level];
-      _level[ai] = _max_level;
+      _level.set(ai,_max_level);
 
       if (_highest_active==level) {
@@ -371,5 +371,5 @@
         }
       copy(i,_first[new_level]);
-      _level[i] = new_level;
+      _level.set(i,new_level);
       if(new_level>_highest_active) _highest_active=new_level;
     }
@@ -383,5 +383,5 @@
     ///\pre The item is on the top level.
     void dirtyTopButOne(Item i) {
-      _level[i] = _max_level - 1;
+      _level.set(i,_max_level - 1);
     }
 
@@ -395,5 +395,5 @@
       const Vit tl=_first[_max_level];
       for(Vit i=f;i!=tl;++i)
-        _level[*i] = _max_level;
+        _level.set(*i,_max_level);
       for(int i=l;i<=_max_level;i++)
         {
@@ -431,9 +431,9 @@
       _last_active[0]=&_items[0]-1;
       Vit n=&_items[0];
-      for(typename ItemSetTraits<GR,Item>::ItemIt i(_g);i!=INVALID;++i)
+      for(typename ItemSetTraits<Graph,Item>::ItemIt i(_g);i!=INVALID;++i)
         {
           *n=i;
-          _where[i] = n;
-          _level[i] = _max_level;
+          _where.set(i,n);
+          _level.set(i,_max_level);
           ++n;
         }
@@ -444,5 +444,5 @@
     {
       swap(_where[i],_init_num);
-      _level[i] = _init_lev;
+      _level.set(i,_init_lev);
       ++_init_num;
     }
@@ -490,8 +490,8 @@
   ///\sa Elevator
   ///
-  ///\param GR Type of the underlying graph.
-  ///\param Item Type of the items the data is assigned to (\c GR::Node,
-  ///\c GR::Arc or \c GR::Edge).
-  template <class GR, class Item>
+  ///\param Graph Type of the underlying graph.
+  ///\param Item Type of the items the data is assigned to (Graph::Node,
+  ///Graph::Arc, Graph::Edge).
+  template <class Graph, class Item>
   class LinkedElevator {
   public:
@@ -502,12 +502,12 @@
   private:
 
-    typedef typename ItemSetTraits<GR,Item>::
+    typedef typename ItemSetTraits<Graph,Item>::
     template Map<Item>::Type ItemMap;
-    typedef typename ItemSetTraits<GR,Item>::
+    typedef typename ItemSetTraits<Graph,Item>::
     template Map<int>::Type IntMap;
-    typedef typename ItemSetTraits<GR,Item>::
+    typedef typename ItemSetTraits<Graph,Item>::
     template Map<bool>::Type BoolMap;
 
-    const GR &_graph;
+    const Graph &_graph;
     int _max_level;
     int _item_num;
@@ -526,5 +526,5 @@
     ///\param max_level The maximum allowed level.
     ///Set the range of the possible labels to <tt>[0..max_level]</tt>.
-    LinkedElevator(const GR& graph, int max_level)
+    LinkedElevator(const Graph& graph, int max_level)
       : _graph(graph), _max_level(max_level), _item_num(_max_level),
         _first(_max_level + 1), _last(_max_level + 1),
@@ -539,6 +539,6 @@
     ///Set the range of the possible labels to <tt>[0..max_level]</tt>,
     ///where \c max_level is equal to the number of labeled items in the graph.
-    LinkedElevator(const GR& graph)
-      : _graph(graph), _max_level(countItems<GR, Item>(graph)),
+    LinkedElevator(const Graph& graph)
+      : _graph(graph), _max_level(countItems<Graph, Item>(graph)),
         _item_num(_max_level),
         _first(_max_level + 1), _last(_max_level + 1),
@@ -552,5 +552,5 @@
     ///\pre Item \c i shouldn't be active before.
     void activate(Item i) {
-      _active[i] = true;
+      _active.set(i, true);
 
       int level = _level[i];
@@ -561,14 +561,14 @@
       if (_prev[i] == INVALID || _active[_prev[i]]) return;
       //unlace
-      _next[_prev[i]] = _next[i];
+      _next.set(_prev[i], _next[i]);
       if (_next[i] != INVALID) {
-        _prev[_next[i]] = _prev[i];
+        _prev.set(_next[i], _prev[i]);
       } else {
         _last[level] = _prev[i];
       }
       //lace
-      _next[i] = _first[level];
-      _prev[_first[level]] = i;
-      _prev[i] = INVALID;
+      _next.set(i, _first[level]);
+      _prev.set(_first[level], i);
+      _prev.set(i, INVALID);
       _first[level] = i;
 
@@ -580,5 +580,5 @@
     ///\pre Item \c i must be active before.
     void deactivate(Item i) {
-      _active[i] = false;
+      _active.set(i, false);
       int level = _level[i];
 
@@ -587,14 +587,14 @@
 
       //unlace
-      _prev[_next[i]] = _prev[i];
+      _prev.set(_next[i], _prev[i]);
       if (_prev[i] != INVALID) {
-        _next[_prev[i]] = _next[i];
+        _next.set(_prev[i], _next[i]);
       } else {
         _first[_level[i]] = _next[i];
       }
       //lace
-      _prev[i] = _last[level];
-      _next[_last[level]] = i;
-      _next[i] = INVALID;
+      _prev.set(i, _last[level]);
+      _next.set(_last[level], i);
+      _next.set(i, INVALID);
       _last[level] = i;
 
@@ -686,5 +686,5 @@
       Item i = _first[_highest_active];
       if (_next[i] != INVALID) {
-        _prev[_next[i]] = INVALID;
+        _prev.set(_next[i], INVALID);
         _first[_highest_active] = _next[i];
       } else {
@@ -692,13 +692,13 @@
         _last[_highest_active] = INVALID;
       }
-      _level[i] = ++_highest_active;
+      _level.set(i, ++_highest_active);
       if (_first[_highest_active] == INVALID) {
         _first[_highest_active] = i;
         _last[_highest_active] = i;
-        _prev[i] = INVALID;
-        _next[i] = INVALID;
-      } else {
-        _prev[_first[_highest_active]] = i;
-        _next[i] = _first[_highest_active];
+        _prev.set(i, INVALID);
+        _next.set(i, INVALID);
+      } else {
+        _prev.set(_first[_highest_active], i);
+        _next.set(i, _first[_highest_active]);
         _first[_highest_active] = i;
       }
@@ -715,5 +715,5 @@
       Item i = _first[_highest_active];
       if (_next[i] != INVALID) {
-        _prev[_next[i]] = INVALID;
+        _prev.set(_next[i], INVALID);
         _first[_highest_active] = _next[i];
       } else {
@@ -721,12 +721,12 @@
         _last[_highest_active] = INVALID;
       }
-      _level[i] = _highest_active = new_level;
+      _level.set(i, _highest_active = new_level);
       if (_first[_highest_active] == INVALID) {
         _first[_highest_active] = _last[_highest_active] = i;
-        _prev[i] = INVALID;
-        _next[i] = INVALID;
-      } else {
-        _prev[_first[_highest_active]] = i;
-        _next[i] = _first[_highest_active];
+        _prev.set(i, INVALID);
+        _next.set(i, INVALID);
+      } else {
+        _prev.set(_first[_highest_active], i);
+        _next.set(i, _first[_highest_active]);
         _first[_highest_active] = i;
       }
@@ -739,7 +739,7 @@
     void liftHighestActiveToTop() {
       Item i = _first[_highest_active];
-      _level[i] = _max_level;
+      _level.set(i, _max_level);
       if (_next[i] != INVALID) {
-        _prev[_next[i]] = INVALID;
+        _prev.set(_next[i], INVALID);
         _first[_highest_active] = _next[i];
       } else {
@@ -775,5 +775,5 @@
       Item i = _first[l];
       if (_next[i] != INVALID) {
-        _prev[_next[i]] = INVALID;
+        _prev.set(_next[i], INVALID);
         _first[l] = _next[i];
       } else {
@@ -781,12 +781,12 @@
         _last[l] = INVALID;
       }
-      _level[i] = ++l;
+      _level.set(i, ++l);
       if (_first[l] == INVALID) {
         _first[l] = _last[l] = i;
-        _prev[i] = INVALID;
-        _next[i] = INVALID;
-      } else {
-        _prev[_first[l]] = i;
-        _next[i] = _first[l];
+        _prev.set(i, INVALID);
+        _next.set(i, INVALID);
+      } else {
+        _prev.set(_first[l], i);
+        _next.set(i, _first[l]);
         _first[l] = i;
       }
@@ -804,5 +804,5 @@
       Item i = _first[l];
       if (_next[i] != INVALID) {
-        _prev[_next[i]] = INVALID;
+        _prev.set(_next[i], INVALID);
         _first[l] = _next[i];
       } else {
@@ -810,12 +810,12 @@
         _last[l] = INVALID;
       }
-      _level[i] = l = new_level;
+      _level.set(i, l = new_level);
       if (_first[l] == INVALID) {
         _first[l] = _last[l] = i;
-        _prev[i] = INVALID;
-        _next[i] = INVALID;
-      } else {
-        _prev[_first[l]] = i;
-        _next[i] = _first[l];
+        _prev.set(i, INVALID);
+        _next.set(i, INVALID);
+      } else {
+        _prev.set(_first[l], i);
+        _next.set(i, _first[l]);
         _first[l] = i;
       }
@@ -833,5 +833,5 @@
       Item i = _first[l];
       if (_next[i] != INVALID) {
-        _prev[_next[i]] = INVALID;
+        _prev.set(_next[i], INVALID);
         _first[l] = _next[i];
       } else {
@@ -839,5 +839,5 @@
         _last[l] = INVALID;
       }
-      _level[i] = _max_level;
+      _level.set(i, _max_level);
       if (l == _highest_active) {
         while (_highest_active >= 0 && activeFree(_highest_active))
@@ -857,21 +857,21 @@
     void lift(Item i, int new_level) {
       if (_next[i] != INVALID) {
-        _prev[_next[i]] = _prev[i];
+        _prev.set(_next[i], _prev[i]);
       } else {
         _last[new_level] = _prev[i];
       }
       if (_prev[i] != INVALID) {
-        _next[_prev[i]] = _next[i];
+        _next.set(_prev[i], _next[i]);
       } else {
         _first[new_level] = _next[i];
       }
-      _level[i] = new_level;
+      _level.set(i, new_level);
       if (_first[new_level] == INVALID) {
         _first[new_level] = _last[new_level] = i;
-        _prev[i] = INVALID;
-        _next[i] = INVALID;
-      } else {
-        _prev[_first[new_level]] = i;
-        _next[i] = _first[new_level];
+        _prev.set(i, INVALID);
+        _next.set(i, INVALID);
+      } else {
+        _prev.set(_first[new_level], i);
+        _next.set(i, _first[new_level]);
         _first[new_level] = i;
       }
@@ -889,5 +889,5 @@
     ///\pre The item is on the top level.
     void dirtyTopButOne(Item i) {
-      _level[i] = _max_level - 1;
+      _level.set(i, _max_level - 1);
     }
 
@@ -900,5 +900,5 @@
         Item n = _first[i];
         while (n != INVALID) {
-          _level[n] = _max_level;
+          _level.set(n, _max_level);
           n = _next[n];
         }
@@ -936,8 +936,8 @@
       }
       _init_level = 0;
-      for(typename ItemSetTraits<GR,Item>::ItemIt i(_graph);
+      for(typename ItemSetTraits<Graph,Item>::ItemIt i(_graph);
           i != INVALID; ++i) {
-        _level[i] = _max_level;
-        _active[i] = false;
+        _level.set(i, _max_level);
+        _active.set(i, false);
       }
     }
@@ -945,14 +945,14 @@
     ///Add an item to the current level.
     void initAddItem(Item i) {
-      _level[i] = _init_level;
+      _level.set(i, _init_level);
       if (_last[_init_level] == INVALID) {
         _first[_init_level] = i;
         _last[_init_level] = i;
-        _prev[i] = INVALID;
-        _next[i] = INVALID;
-      } else {
-        _prev[i] = _last[_init_level];
-        _next[i] = INVALID;
-        _next[_last[_init_level]] = i;
+        _prev.set(i, INVALID);
+        _next.set(i, INVALID);
+      } else {
+        _prev.set(i, _last[_init_level]);
+        _next.set(i, INVALID);
+        _next.set(_last[_init_level], i);
         _last[_init_level] = i;
       }
Index: lemon/euler.h
===================================================================
--- lemon/euler.h	(revision 592)
+++ lemon/euler.h	(revision 522)
@@ -25,44 +25,46 @@
 #include <list>
 
-/// \ingroup graph_properties
+/// \ingroup graph_prop
 /// \file
-/// \brief Euler tour iterators and a function for checking the \e Eulerian 
-/// property.
+/// \brief Euler tour
 ///
-///This file provides Euler tour iterators and a function to check
-///if a (di)graph is \e Eulerian.
+///This file provides an Euler tour iterator and ways to check
+///if a digraph is euler.
+
 
 namespace lemon {
 
-  ///Euler tour iterator for digraphs.
+  ///Euler iterator for digraphs.
 
   /// \ingroup graph_prop
-  ///This iterator provides an Euler tour (Eulerian circuit) of a \e directed
-  ///graph (if there exists) and it converts to the \c Arc type of the digraph.
+  ///This iterator converts to the \c Arc type of the digraph and using
+  ///operator ++, it provides an Euler tour of a \e directed
+  ///graph (if there exists).
   ///
-  ///For example, if the given digraph has an Euler tour (i.e it has only one
-  ///non-trivial component and the in-degree is equal to the out-degree 
-  ///for all nodes), then the following code will put the arcs of \c g
-  ///to the vector \c et according to an Euler tour of \c g.
+  ///For example
+  ///if the given digraph is Euler (i.e it has only one nontrivial component
+  ///and the in-degree is equal to the out-degree for all nodes),
+  ///the following code will put the arcs of \c g
+  ///to the vector \c et according to an
+  ///Euler tour of \c g.
   ///\code
   ///  std::vector<ListDigraph::Arc> et;
-  ///  for(DiEulerIt<ListDigraph> e(g); e!=INVALID; ++e)
+  ///  for(DiEulerIt<ListDigraph> e(g),e!=INVALID;++e)
   ///    et.push_back(e);
   ///\endcode
-  ///If \c g has no Euler tour, then the resulted walk will not be closed
-  ///or not contain all arcs.
+  ///If \c g is not Euler then the resulted tour will not be full or closed.
   ///\sa EulerIt
-  template<typename GR>
+  template<class Digraph>
   class DiEulerIt
   {
-    typedef typename GR::Node Node;
-    typedef typename GR::NodeIt NodeIt;
-    typedef typename GR::Arc Arc;
-    typedef typename GR::ArcIt ArcIt;
-    typedef typename GR::OutArcIt OutArcIt;
-    typedef typename GR::InArcIt InArcIt;
-
-    const GR &g;
-    typename GR::template NodeMap<OutArcIt> narc;
+    typedef typename Digraph::Node Node;
+    typedef typename Digraph::NodeIt NodeIt;
+    typedef typename Digraph::Arc Arc;
+    typedef typename Digraph::ArcIt ArcIt;
+    typedef typename Digraph::OutArcIt OutArcIt;
+    typedef typename Digraph::InArcIt InArcIt;
+
+    const Digraph &g;
+    typename Digraph::template NodeMap<OutArcIt> nedge;
     std::list<Arc> euler;
 
@@ -71,46 +73,36 @@
     ///Constructor
 
-    ///Constructor.
-    ///\param gr A digraph.
-    ///\param start The starting point of the tour. If it is not given,
-    ///the tour will start from the first node that has an outgoing arc.
-    DiEulerIt(const GR &gr, typename GR::Node start = INVALID)
-      : g(gr), narc(g)
-    {
-      if (start==INVALID) {
-        NodeIt n(g);
-        while (n!=INVALID && OutArcIt(g,n)==INVALID) ++n;
-        start=n;
-      }
-      if (start!=INVALID) {
-        for (NodeIt n(g); n!=INVALID; ++n) narc[n]=OutArcIt(g,n);
-        while (narc[start]!=INVALID) {
-          euler.push_back(narc[start]);
-          Node next=g.target(narc[start]);
-          ++narc[start];
-          start=next;
-        }
-      }
-    }
-
-    ///Arc conversion
+    ///\param _g A digraph.
+    ///\param start The starting point of the tour. If it is not given
+    ///       the tour will start from the first node.
+    DiEulerIt(const Digraph &_g,typename Digraph::Node start=INVALID)
+      : g(_g), nedge(g)
+    {
+      if(start==INVALID) start=NodeIt(g);
+      for(NodeIt n(g);n!=INVALID;++n) nedge[n]=OutArcIt(g,n);
+      while(nedge[start]!=INVALID) {
+        euler.push_back(nedge[start]);
+        Node next=g.target(nedge[start]);
+        ++nedge[start];
+        start=next;
+      }
+    }
+
+    ///Arc Conversion
     operator Arc() { return euler.empty()?INVALID:euler.front(); }
-    ///Compare with \c INVALID
     bool operator==(Invalid) { return euler.empty(); }
-    ///Compare with \c INVALID
     bool operator!=(Invalid) { return !euler.empty(); }
 
     ///Next arc of the tour
-
-    ///Next arc of the tour
-    ///
     DiEulerIt &operator++() {
       Node s=g.target(euler.front());
       euler.pop_front();
+      //This produces a warning.Strange.
+      //std::list<Arc>::iterator next=euler.begin();
       typename std::list<Arc>::iterator next=euler.begin();
-      while(narc[s]!=INVALID) {
-        euler.insert(next,narc[s]);
-        Node n=g.target(narc[s]);
-        ++narc[s];
+      while(nedge[s]!=INVALID) {
+        euler.insert(next,nedge[s]);
+        Node n=g.target(nedge[s]);
+        ++nedge[s];
         s=n;
       }
@@ -119,8 +111,6 @@
     ///Postfix incrementation
 
-    /// Postfix incrementation.
-    ///
     ///\warning This incrementation
-    ///returns an \c Arc, not a \ref DiEulerIt, as one may
+    ///returns an \c Arc, not an \ref DiEulerIt, as one may
     ///expect.
     Arc operator++(int)
@@ -132,40 +122,42 @@
   };
 
-  ///Euler tour iterator for graphs.
-
-  /// \ingroup graph_properties
-  ///This iterator provides an Euler tour (Eulerian circuit) of an
-  ///\e undirected graph (if there exists) and it converts to the \c Arc
-  ///and \c Edge types of the graph.
+  ///Euler iterator for graphs.
+
+  /// \ingroup graph_prop
+  ///This iterator converts to the \c Arc (or \c Edge)
+  ///type of the digraph and using
+  ///operator ++, it provides an Euler tour of an undirected
+  ///digraph (if there exists).
   ///
-  ///For example, if the given graph has an Euler tour (i.e it has only one 
-  ///non-trivial component and the degree of each node is even),
+  ///For example
+  ///if the given digraph if Euler (i.e it has only one nontrivial component
+  ///and the degree of each node is even),
   ///the following code will print the arc IDs according to an
   ///Euler tour of \c g.
   ///\code
-  ///  for(EulerIt<ListGraph> e(g); e!=INVALID; ++e) {
+  ///  for(EulerIt<ListGraph> e(g),e!=INVALID;++e) {
   ///    std::cout << g.id(Edge(e)) << std::eol;
   ///  }
   ///\endcode
-  ///Although this iterator is for undirected graphs, it still returns 
-  ///arcs in order to indicate the direction of the tour.
-  ///(But arcs convert to edges, of course.)
+  ///Although the iterator provides an Euler tour of an graph,
+  ///it still returns Arcs in order to indicate the direction of the tour.
+  ///(But Arc will convert to Edges, of course).
   ///
-  ///If \c g has no Euler tour, then the resulted walk will not be closed
-  ///or not contain all edges.
-  template<typename GR>
+  ///If \c g is not Euler then the resulted tour will not be full or closed.
+  ///\sa EulerIt
+  template<class Digraph>
   class EulerIt
   {
-    typedef typename GR::Node Node;
-    typedef typename GR::NodeIt NodeIt;
-    typedef typename GR::Arc Arc;
-    typedef typename GR::Edge Edge;
-    typedef typename GR::ArcIt ArcIt;
-    typedef typename GR::OutArcIt OutArcIt;
-    typedef typename GR::InArcIt InArcIt;
-
-    const GR &g;
-    typename GR::template NodeMap<OutArcIt> narc;
-    typename GR::template EdgeMap<bool> visited;
+    typedef typename Digraph::Node Node;
+    typedef typename Digraph::NodeIt NodeIt;
+    typedef typename Digraph::Arc Arc;
+    typedef typename Digraph::Edge Edge;
+    typedef typename Digraph::ArcIt ArcIt;
+    typedef typename Digraph::OutArcIt OutArcIt;
+    typedef typename Digraph::InArcIt InArcIt;
+
+    const Digraph &g;
+    typename Digraph::template NodeMap<OutArcIt> nedge;
+    typename Digraph::template EdgeMap<bool> visited;
     std::list<Arc> euler;
 
@@ -174,54 +166,45 @@
     ///Constructor
 
-    ///Constructor.
-    ///\param gr A graph.
-    ///\param start The starting point of the tour. If it is not given,
-    ///the tour will start from the first node that has an incident edge.
-    EulerIt(const GR &gr, typename GR::Node start = INVALID)
-      : g(gr), narc(g), visited(g, false)
-    {
-      if (start==INVALID) {
-        NodeIt n(g);
-        while (n!=INVALID && OutArcIt(g,n)==INVALID) ++n;
-        start=n;
-      }
-      if (start!=INVALID) {
-        for (NodeIt n(g); n!=INVALID; ++n) narc[n]=OutArcIt(g,n);
-        while(narc[start]!=INVALID) {
-          euler.push_back(narc[start]);
-          visited[narc[start]]=true;
-          Node next=g.target(narc[start]);
-          ++narc[start];
-          start=next;
-          while(narc[start]!=INVALID && visited[narc[start]]) ++narc[start];
-        }
-      }
-    }
-
-    ///Arc conversion
+    ///\param _g An graph.
+    ///\param start The starting point of the tour. If it is not given
+    ///       the tour will start from the first node.
+    EulerIt(const Digraph &_g,typename Digraph::Node start=INVALID)
+      : g(_g), nedge(g), visited(g,false)
+    {
+      if(start==INVALID) start=NodeIt(g);
+      for(NodeIt n(g);n!=INVALID;++n) nedge[n]=OutArcIt(g,n);
+      while(nedge[start]!=INVALID) {
+        euler.push_back(nedge[start]);
+        visited[nedge[start]]=true;
+        Node next=g.target(nedge[start]);
+        ++nedge[start];
+        start=next;
+        while(nedge[start]!=INVALID && visited[nedge[start]]) ++nedge[start];
+      }
+    }
+
+    ///Arc Conversion
     operator Arc() const { return euler.empty()?INVALID:euler.front(); }
-    ///Edge conversion
+    ///Arc Conversion
     operator Edge() const { return euler.empty()?INVALID:euler.front(); }
-    ///Compare with \c INVALID
+    ///\e
     bool operator==(Invalid) const { return euler.empty(); }
-    ///Compare with \c INVALID
+    ///\e
     bool operator!=(Invalid) const { return !euler.empty(); }
 
     ///Next arc of the tour
-
-    ///Next arc of the tour
-    ///
     EulerIt &operator++() {
       Node s=g.target(euler.front());
       euler.pop_front();
       typename std::list<Arc>::iterator next=euler.begin();
-      while(narc[s]!=INVALID) {
-        while(narc[s]!=INVALID && visited[narc[s]]) ++narc[s];
-        if(narc[s]==INVALID) break;
+
+      while(nedge[s]!=INVALID) {
+        while(nedge[s]!=INVALID && visited[nedge[s]]) ++nedge[s];
+        if(nedge[s]==INVALID) break;
         else {
-          euler.insert(next,narc[s]);
-          visited[narc[s]]=true;
-          Node n=g.target(narc[s]);
-          ++narc[s];
+          euler.insert(next,nedge[s]);
+          visited[nedge[s]]=true;
+          Node n=g.target(nedge[s]);
+          ++nedge[s];
           s=n;
         }
@@ -232,8 +215,7 @@
     ///Postfix incrementation
 
-    /// Postfix incrementation.
-    ///
-    ///\warning This incrementation returns an \c Arc (which converts to 
-    ///an \c Edge), not an \ref EulerIt, as one may expect.
+    ///\warning This incrementation
+    ///returns an \c Arc, not an \ref EulerIt, as one may
+    ///expect.
     Arc operator++(int)
     {
@@ -245,40 +227,35 @@
 
 
-  ///Check if the given graph is \e Eulerian
-
-  /// \ingroup graph_properties
-  ///This function checks if the given graph is \e Eulerian.
-  ///It works for both directed and undirected graphs.
-  ///
-  ///By definition, a digraph is called \e Eulerian if
-  ///and only if it is connected and the number of incoming and outgoing
+  ///Checks if the graph is Eulerian
+
+  /// \ingroup graph_prop
+  ///Checks if the graph is Eulerian. It works for both directed and undirected
+  ///graphs.
+  ///\note By definition, a digraph is called \e Eulerian if
+  ///and only if it is connected and the number of its incoming and outgoing
   ///arcs are the same for each node.
   ///Similarly, an undirected graph is called \e Eulerian if
-  ///and only if it is connected and the number of incident edges is even
-  ///for each node.
-  ///
-  ///\note There are (di)graphs that are not Eulerian, but still have an
-  /// Euler tour, since they may contain isolated nodes.
-  ///
-  ///\sa DiEulerIt, EulerIt
-  template<typename GR>
+  ///and only if it is connected and the number of incident arcs is even
+  ///for each node. <em>Therefore, there are digraphs which are not Eulerian,
+  ///but still have an Euler tour</em>.
+  template<class Digraph>
 #ifdef DOXYGEN
   bool
 #else
-  typename enable_if<UndirectedTagIndicator<GR>,bool>::type
-  eulerian(const GR &g)
-  {
-    for(typename GR::NodeIt n(g);n!=INVALID;++n)
+  typename enable_if<UndirectedTagIndicator<Digraph>,bool>::type
+  eulerian(const Digraph &g)
+  {
+    for(typename Digraph::NodeIt n(g);n!=INVALID;++n)
       if(countIncEdges(g,n)%2) return false;
     return connected(g);
   }
-  template<class GR>
-  typename disable_if<UndirectedTagIndicator<GR>,bool>::type
+  template<class Digraph>
+  typename disable_if<UndirectedTagIndicator<Digraph>,bool>::type
 #endif
-  eulerian(const GR &g)
-  {
-    for(typename GR::NodeIt n(g);n!=INVALID;++n)
+  eulerian(const Digraph &g)
+  {
+    for(typename Digraph::NodeIt n(g);n!=INVALID;++n)
       if(countInArcs(g,n)!=countOutArcs(g,n)) return false;
-    return connected(undirector(g));
+    return connected(Undirector<const Digraph>(g));
   }
 
Index: lemon/full_graph.h
===================================================================
--- lemon/full_graph.h	(revision 582)
+++ lemon/full_graph.h	(revision 440)
@@ -158,6 +158,7 @@
   /// constant space in memory.
   ///
-  /// This class fully conforms to the \ref concepts::Digraph
-  /// "Digraph concept".
+  /// This class conforms to the \ref concepts::Digraph "Digraph" concept
+  /// and it also has an important extra feature that its maps are
+  /// real \ref concepts::ReferenceMap "reference map"s.
   ///
   /// The \c FullDigraph and \c FullGraph classes are very similar,
@@ -527,5 +528,7 @@
   /// space in memory.
   ///
-  /// This class fully conforms to the \ref concepts::Graph "Graph concept".
+  /// This class conforms to the \ref concepts::Graph "Graph" concept
+  /// and it also has an important extra feature that its maps are
+  /// real \ref concepts::ReferenceMap "reference map"s.
   ///
   /// The \c FullGraph and \c FullDigraph classes are very similar,
